# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define	section		free

Name:		gjt-jpl-pattern
Summary:	Support for using design patterns.
Url:		http://www.gjt.org/pkgdoc/org/gjt/lindfors/pattern/index.html
Version:	0.2
Release:	4%{?dist}
Epoch:		0
License:	GPL
Group:		Development/Libraries/Java
BuildArch:	noarch
Source0:	gjt-jpl-pattern-source.zip
# download http://www.gjt.org/servlets/JCVSlet/zip/gjt/org/gjt/lindfors/pattern/pattern.zip
Source1:	gjt-jpl-pattern-build.xml
Source2:	http://repository.jboss.com/maven2/jpl-pattern/jpl-pattern/1.0/jpl-pattern-1.0.pom

BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:	ant
Requires:  java >= 0:1.5.0
Requires(post):   jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3

BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
This package consists mainly of interfaces used to recognize 
well known design patterns in a software system. Most 
interfaces are only useful for 'tagging' classes as being a 
part of certain design patterns, and there isn't any 
implementing code present here. 

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:	Documents for %{name}
Group:		Development/Documentation

%description manual
%{summary}.

%prep
%setup -qq -c -n %{name}-%{version}
chmod -R go=u-w *
find . -name "*.jar" -exec rm -f {} \;
mkdir -p pattern/build
cp %{SOURCE1} pattern/build/build.xml

%build
mkdir pattern/classes
ant -f pattern/build/build.xml lib javadoc

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 pattern/build/jpl-pattern-0_2.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap jpl-pattern jpl-pattern %{version} JPP %{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr pattern/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr pattern/doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%{_docdir}/%{name}-%{version}/LICENSE
%{_javadir}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root)
%{_docdir}/%{name}-%{version}

%changelog
* Fri Mar 13 2009 Ralph Apel <r.apel@r-apel.de> 0:0.2-4.jpp5
- First JPP 5.0 build
- Add pom and depmap frag

* Fri Apr 21 2006 Fernando Nasser <fnasser@redhat.com> 0:0.2-3jpp
- First JPP 1.7 build

* Mon Aug 23 2004 Ralph Apel <r.apel at r-apel.de> 0:%{version}-2jpp
- Build with ant-1.6.2

* Mon Jul 26 2004 Ralph Apel <r.apel at r-apel.de> 0:%{version}-1jpp
- First JPackage release
